HP-15C: Preferences

Version 4.5.00, Build 6308
© 2023 Torsten Manz
H E W L E T T · P A C K A R D 15C
A Simulator for Windows, Linux and macOS

# Preferences

The Preferences dialogue allows you to change the Simulator parameters. You can find it in the ON popup menu: Alt–O Preferences…

Press OK or Apply to activate the new settings for the current session. The settings are not saved on the hard disk and therefore not made persistent until you save the current session. If you have unchecked Save on exit (see below), you must save the current session manually by pressing Ctrl–M.

The following items can be set in the dialogue box. Default values are used if no memory file is found at start-up.

## Simulator

- Strict HP-15C behaviour

  The real HP-15C stores numbers internally with 10 digits, and rounds every result to the 10th digit. The Tcl/Tk interpreter stores numbers in the IEEE-754 format with 17 digits and a different rounding mechanism. When this option is checked, the number of relevant digits is set to 10 and every number ist rounded to that digit.

  The following calculation shows the effect of the two settings:

  f FIX 9

  2 ENTER 3 ÷

  0 . 6 6 −

  1 0 0 0 ×

  Result with strict HP-15C behaviour checked (10 digit precision):

  Result with strict HP-15C behaviour not checked (17 digit precision):

  In the second case, rounding to the last digit only takes place in the display. Internally the number is stored as `6.666666666666599`, providing the full precision. Further information can be found in the section on number encoding in the Differences section.

  Default: Off

- Pause length

  Time in milliseconds that a program pauses during execution when it encounters an f PSE statement. The valid range is 0 to 2000.

  This is also the time the display update is deferred after releasing the last key in f PREFIX, g MEM and f i.

  Default: 1000

- Delay value

  Time in milliseconds that a program pauses after each statement. A value of around 100 gives a good impression of the performance of the real HP-15C. A value of 0 gives maximum performance. The valid range is 0 to 999.

  Default: 0

- Access 'f' and 'g' functions directly

  If this option is checked, you can click directly on the gold and blue secondary functions. You do not need to press or click f or g before. If unchecked, the gold functions can not be clicked and clicking a blue function is the same as clicking the main key function.

  Default: On

- Highlight functions

  This option enables mouse-over effects for the blue and gold labels, if direct access to the f and g functions is enabled.

  Default: On

- Key sequence indicator

  The key sequence indicator is a small black square in the lower left corner of the display. It indicates an uncompleted sequence. For example, if you press STO, the indicator lights up. If you now press 7 the indicator goes out, because the key sequence is complete. If instead you continue with the + key, the indicator remains on. The Simulator is still waiting for the storage register value.

  The key sequence indicator is disabled during program execution.

  This function is inspired by the similar function on the DM15/DM15L from SwissMicros.

  Default: Off

- Save memory on exit

  If checked, continuous memory is enabled. When you exit the Simulator, the status is saved to disk.

  If you uncheck this option, you must save the memory manually to make the new setting persistent!

  Default: On

- Use "C locale" for clipboard

  If this option is checked, a period is used as decimal point in the clipboard. The setting is independent of the current display settings for the decimal point and the digit separator.

  Default: Off

- Copy program when in PRGM mode

  By default, pressing Ctrl–C copies the content of the X-register to the clipboard. If this option is checked and the Simulator is in PRGM mode, Ctrl–C copies the program code to the clipboard instead.

  Default: Off

- Save window position

  The last window position of the simulator is saved when set. The simulator will open at that the position, the next time it is started.
  If the simulator window will not be fully visible at the old position, the value is ignored. The simulator is then placed by the OS' window manager.

  Default: Off

◀ Simulator ▲ Top

## Menus

- Show menu

  Under Windows and Linux, this activates a menu bar at the top of the simulator window.
  Under macOS, the menu bar on top of the screen is always on.

  Default: Off (always checked under macOS)

- Native macOS popup menus

  Earlier Tcl/Tk versions did not allow fixed-width fonts in popup menus under macOS; a feature needed for the simulator popup menus. Newer combinations of Tcl/Tk and macOS; no longer have this limitation and native popup menus are now used by default. Uncheck this option if you experience problems with the stack and the memory popup menu.

  Default: On

- Number of recent programs

  The number of entries in the recent programs submenu. The valid range is 10 to 30.

  Default: 10

- Show full path

  If this option is checked, the full path of a recent program is shown in the submenu. If unchecked, only the file name is shown.

  Default: Off

- Program mnemonics

  If this option is checked, the program popup menu (Alt–S) displays program steps as mnemonics. If unchecked, the program steps are displayed with their key codes. Please note that this setting has no effect on the display.

  Default: On

- Coloured program menu

  If this option is checked, the program popup menu shows LBL, RTN, GTO and GSB statements coloured.

  Default: On

- Lines per column in program menu

  The program popup menu shows the program steps in a multi-column format. This value defines the number of program steps per column. The valid range is 10 to 50.

  Default: 30

- Register and label addresses with decimal point

  This option controls how addresses of storage registers and labels between 10 and 19 are displayed. When enabled, the address is formatted with a decimal point, e.g. `,0` or `.0`, and as two-digit integer, e.g. `10`, when disabled.

  The option changes the format in the following situations:

  - Storage register menu
  - Program menu (if mnenomics are switched off)
  - GSB menu
  - Documentation dialogue
  - HTML export

  Default: Off

- Two-column storage menu

  By default, the storage popup menus show the available data storage registers in two columns. Uncheck this setting if you want the storage menus with all data storage registers displayed in one column.

  macOS: This option has has no effect when "Native macOS popup menus" (see below) is activated. macOS does not allow multi-column popup menus.

  Default: On

- Storage register descriptions

  The storage register description from a loaded program can be shown in the storage menus. Only the first 25 characters will be shown.

  Default: Off

- Sort labels in GSB menu

  This controls whether the labels in the GSB menu are sorted or whether they are listed in the order in which they occur in the program. If the labels are sorted, the letter labels are sorted before the number labels.

  Default: Off

- Matrix notation

  Two different styles are available for the matrix content menus: One with row and column headers like in a spreadsheet and one with the "row,column" information before each matrix element.

  Default: Rows/Columns

- Matrix separator

  When a matrix descriptor is shown in the display, pressing Ctrl–C copies the content of the matrix to the clipboard. One line for each row and the elements of a row seperated by the selected separator.
  Be careful when selecting the "comma" as the separator, because it might conflict with the thousands separator or the decimal point character.

  Default: Semicolon

- Matrix submenus in stack menu

  A matrix entry in the stack menu can be either a submenu button or just a label. In case of a submenu button, moving the mouse over the button opens a submenu with the contents of the matrix.

  macOS: This only works if "Native macOS popup menus" are enabled.
  Windows, Linux: If matrix submenus are enabled, clicking an entry, e.g. "`y: A 2 2 ▶`, does not scroll down the stack.

  Default: On

- Language

  This controls the language for menus and pop-ups. By default the system language is used. If this language is not supported, British English is selected. The new setting is active immediately, except for the Preferences dialogue. This dialogue box will use the new language the next time it is opened.

  Default: System

◀ Menus ▲ Top

## Files

### HP-15C Programs

- Encode programs in UTF-16 (LE)

  By default, the program files are encoded in UTF-16 (LE). Uncheck this option to encode them in the system default encoding.
  Please note that HTML exports are always encoded in UTF-8.

  Default: On

- Confirm overwrite

  Defines the behaviour of the "Save program" dialogue when the selected file already exists. If set, the dialogue requests a confirmation before overwriting the existing file. If not set, the overwrites takes place without a confirmation.

  Default: On

### HTML Files

- Structure in English

  This settings determines which language is used for HTML headlines (`<h#>`), such as "Program Title", "Usage", etc., when exporting a program description to an HTML file. If this option is checked, British English is used; if the option is unchecked, the currently selected menu language is used.

  This setting has no effect on the text of the program description itself.

  Default: On

- Indent subroutines

  If this option is checked, subroutines in the HTML export are indented to show the program structure. The start of a subroutine, i.e. f LBL followed by A…E, 0…9 or . 0…9 and the end, i.e. g RTN, are not indented.

  Default: On

- Warn on missing documentation

  If this option is checked, a warning message is shown if you export a file as HTML and one of the following elements is empty:

  - Program
  - Program Title
  - Usage

  Default: On

- Single-column program listing

  By default, the program listing uses one column for programs with up to 25 steps, two columns for up to 50 steps and three columns for programs with 51 or more steps. When this option is checked, the program listing uses always only one column.

  Default: Off

- Keys in black and white

  By default, the keys are printed in colour. Enable this option to print them in black and white.
  This can be helpful if you print out the documentation on a black and white printer, such as a laser printer.

  Default: Off

### Description

- Open after loading a program

  If activated, the Program Description Dialogue will open automatically after loading a program.

  Default: Off

- Automatic preview

  If this option is checked and the "Usage" field of a program description contains HTML tags or entities, the Program Description Dialogue opens in preview mode. Otherwise it will open in "Edit" mode. Once the dialogue is open, you can switch between the two modes.

  Default: On

- Always insert Unicode characters

  If activated, the symbols are inserted as Unicode characters. If deactivate, HTML Entities are inserted. This has no effect on Preview Mode; Unicode characters and corresponding HTML Entities will look the same.

  Default: On

- Toolbar style

  The buttons of the HTML tags toolbar can show icons or text.

  Default: Icons

- Show icons in tag menu

  Enables or disables icons in the context menu. Under macOS context menu normally do not have menu item icons.

  Default: Window, Linux: On; macOS: Off

- Highlight tags

  This section provides options to configure how tags are displayed in the "Usage" part of the Program Description Dialogue.

  Defaults: Colour: #800080 (RGB 128, 0, 128), bold: checked

- Text markers

  Allows to set the colour used to "Mark all" occurrences of a text in the program description in Edit mode.

  Default: #FFFF00 (RGB 255, 255, 0)

- Show resources in tabs

  Resources can be grouped either as a block or in individual tabs for Labels, Memory Registers and Flags.

  This does not affect whether the resources are displayed at all. This is controlled by the "Resource" button below the description.

  Default: On

- Author information

  Information about the authorship of programs can be added in this field. This value is inserted into an empty "Usage" field, when the Program Description Dialogue is openend.

  Default: Empty

◀ Files ▲ Top

## DM15

- DM15 Support

  This switches the support for the DM15 on and off, e.g. the menu items of the DM15 become visible or hidden.

  Default: Off

- Serial Interface Port

  The number of the serial port assigned by the operating system to the USB connection of the DM15.

  Default: Not set

- Timeout

  The timeout in seconds for the serial interface.

  Default: 2 seconds

- Number of registers

  Sets the number of data storage registers available in the HP-15C Simulator. This should correspond with the number of registers on the DM15.

  Default: 64 registers

- Transmitted data The ten check boxes, five for reading and five for writing, determine which data is exchanged between the DM15 and the HP-15C Simulator.

  Default: "Program" checked for both reading and writing.

- Ask for each operation

  When this option is checked the data to be exchanged between the source and the target device is queried interactively for each operation. The selection is set as the default for the next operation.

  Default: On

◀ DM-15 ▲ Top

## Fonts

- Font set

  The Simulator layout depends very much on the combination of fonts, font sizes and the resolution of the display. The Simulator therefore provides predefined font sets for common display resolutions. These font sets have been fine-tuned to achieve a good reproduction of the real HP-15C body aspect ratio that meets the "Golden Ratio".

  The following table lists the available font sets for each platform and display resolution:

  Platform | Font set | Size | Fonts used in set
  --- | --- | --- | ---
  UNIX/Linux Mac OS | DejaVu fonts | small, normal, large and huge | DejaVu Sans
  Microsoft fonts | small and normal | Arial Microsoft Sans Serif
  MS Windows (all versions) | Microsoft fonts | small, normal, large and huge | Arial Microsoft Small Fonts Microsoft Sans Serif

  Remarks:

  - The "HP-15C Simulator Font" is used with all sets.
  - If you want to change fonts or font sizes or add new font sets, you have to edit the Simulator source code. I suggest not changing existing font sets at all.
  - "DejaVu" fonts can be found on the Internet (see the links page).

- Extended Unicode chars for key faces

  The Simulator can use specific Unicode characters to make the key faces look more like the original HP-15C key faces.

  All current operating systems should provide fonts with the necessary characters. If you have checked this option and a character is not available, you will see key faces like

  instead of or instead of .

  In this case, you should uncheck the option or install a suitable font.

  Default: On

- Graphic display instead of "HP15C Simulator Font" (Windows only)

  When this options is active, a graphical display is used instead of the the 'HP-15C Simulator Font'.
  This is useful when you need administrator privileges to install a font but cannot obtain them; e.g. on company computers.
  Please note that this reduces the Simulator performance by about 30%!

  Default: Off

◀ Fonts ▲ Top

## Help File Browser

This setting allows you to set the browser used to display the online help.

When you start the Simulator for the first time, or if no browser is set, the Simulator checks for available browsers in all directories specified by the environment variable "`PATH`". If available, the operating system's default method to open a Web page is added at the top of the browser list. This results in the following list of possible browsers per operating system:

Platform | Browser list
--- | ---
UNIX/Linux | `firefox chrome mozilla opera konquerer`
macOS | `open firefox safari chrome opera`
Windows | `start firefox safari chrome mozilla opera iexplore hh`

Remarks:

- open in the macOS list will always run the default browser.
- start in the Windows list will always run the default browser.
- hh is the browser used with the online help on Windows XP/Vista/7.

All browsers found are listed, and the first one in the list is set as the help file browser. You can choose another browser from the list or you can select one using the Browse… button

◀ Browser ▲ Top

FAQ ▶